package com.jasamedika.medifirst2000.controller;

import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.IBaseRestController;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.entities.NotaDinasJabatan;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.NotaDinasService;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.NotaDinasJabatanVO;
import com.jasamedika.medifirst2000.vo.NotaDinasVO;

import net.kaczmarzyk.spring.data.jpa.domain.DateBetween;
import net.kaczmarzyk.spring.data.jpa.web.annotation.Spec;

@RestController
@RequestMapping("/nota-dinas")
public class NotaDinasController extends LocaleController<NotaDinasVO> implements IBaseRestController<NotaDinasVO>{
	
	@Autowired
	private NotaDinasService notaDinasService;
	
	private static final Logger LOGGER = LoggerFactory.getLogger(NotaDinasController.class);
	
	@RequestMapping(value = "/save-nota-dinas/", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> addVO(@Valid @RequestBody NotaDinasVO vo, HttpServletRequest request) {
		
		try {
			Map<String,Object> result=notaDinasService.addNotaDinas(vo);
			if (null != result)
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED,mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add nota-dinas", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR,
					mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add nota-dinas", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT,
					mapHeaderMessage);
		}
	}
	
	@RequestMapping(value = "/get-no-surat/", method = RequestMethod.GET)
	public ResponseEntity<Map<String,Object>> getNoSurat(HttpServletRequest request) {
		
		try {
			String noSurat=notaDinasService.getNoSurat();
			System.out.println("Lukman debug "+ noSurat);
			Map<String,Object> result=new HashMap<String,Object>();
			result.put("noSurat", noSurat);
			if (null != result)
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
			return RestUtil.getJsonResponse(result, HttpStatus.OK,mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add nota-dinas", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR,
					mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add nota-dinas", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT,
					mapHeaderMessage);
		}
	}
	
	@SuppressWarnings("unchecked")
	@RequestMapping(value = "/grid-nota-dinas")
	@ResponseBody
	public ResponseEntity<List<Object>>  andCondition(
			@RequestParam(value = "page", required = false, defaultValue = "0") Integer page,
			@RequestParam(value = "take", required = false, defaultValue = "10") Integer limit,
			@RequestParam(value = "sort", required = false, defaultValue = "noRec") String sort,
			@RequestParam(value = "dir", required = false, defaultValue = "asc") String dir,
			@Spec(path = "notaDinas.tanggal", params = {"tanggalAwal", "tanggalAhir"}, config = "yyyy-MM-dd", spec = DateBetween.class)Specification<NotaDinasJabatan> spec){
		
		Map<String, Object> resultPageMap = notaDinasService.gridNotaDinas(page, limit, sort, dir, spec);
		
		return constructListPageResult(resultPageMap);
	}
	

	@RequestMapping(value = "/get-detail-nota-dinas", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<NotaDinasVO> findByNoRec(@RequestParam(value = "noRec", required = true) String noRec){
		NotaDinasVO notaDinas = notaDinasService.findByNoRec(noRec);

		try {
			return RestUtil.getJsonResponse(notaDinas, HttpStatus.OK, mapHeaderMessage);
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		}
		return RestUtil.getJsonResponse(null, HttpStatus.NOT_FOUND, mapHeaderMessage);
	}
	@RequestMapping(value = "/get-inbox-nota-dinas", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<List<Map<String, Object>>> getInboxNotaDinas( 
			@RequestParam(value = "flag", required = false) String flag,
			@RequestParam(value = "dateStart", required = false) String dateStart,
			@RequestParam(value = "dateEnd", required = false) String dateEnd,
			@RequestParam(value = "idRuangan", required = false) Integer idRuangan,
			@RequestParam(value = "idPegawai", required = false) Integer idPegawai){
		List<Map<String, Object>> notaDinas = notaDinasService.getInboxNotaDinas(dateStart, dateEnd, idRuangan, flag,idPegawai);

		try {
			return RestUtil.getJsonResponse(notaDinas, HttpStatus.OK, mapHeaderMessage);
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		}
		return RestUtil.getJsonResponse(null, HttpStatus.NOT_FOUND, mapHeaderMessage);
	}
	@RequestMapping(value = "/get-outbox-nota-dinas", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<List<Map<String, Object>>> getOutboxNotaDinas( 
			@RequestParam(value = "flag", required = false) String flag,
			@RequestParam(value = "dateStart", required = false) String dateStart,
			@RequestParam(value = "dateEnd", required = false) String dateEnd,
			@RequestParam(value = "idRuangan", required = false) Integer idRuangan,
			@RequestParam(value = "idPegawai", required = false) Integer idPegawai){
		List<Map<String, Object>> notaDinas = notaDinasService.getOutboxNotaDinas(dateStart,dateEnd,idRuangan,flag,idPegawai);

		try {
			return RestUtil.getJsonResponse(notaDinas, HttpStatus.OK, mapHeaderMessage);
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		}
		return RestUtil.getJsonResponse(null, HttpStatus.NOT_FOUND, mapHeaderMessage);
	}
	@RequestMapping(value = "/save-nota-dinas-as-read/", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<String> saveAsReadNotaDinas(@RequestBody NotaDinasJabatanVO vo, HttpServletRequest request) {
		
		try {
			String result=notaDinasService.saveAsRead(vo);
			if (null != result)
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED,mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add nota-dinas", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR,
					mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add nota-dinas", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT,
					mapHeaderMessage);
		}
	}
	@Override
	public ResponseEntity<Collection<NotaDinasVO>> getAllVOWithQueryString(HttpServletRequest request, Integer page,
			Integer limit, String sort, String dir) {
		return null;
	}

	@Override
	public ResponseEntity<NotaDinasVO> getVO(Integer id) {
		return null;
	}

	@Override
	public ResponseEntity<String> addVO(NotaDinasVO vo) {
		return null;
	}

	@Override
	public ResponseEntity<String> editVO(NotaDinasVO vo) {
		return null;
	}

	@Override
	public ResponseEntity<String> deleteVO(Integer id) {
		return null;
	}

	@Override
	public ResponseEntity<List<NotaDinasVO>> getAllVO() {
		return null;
	}
	
}
